# coding: utf-8

"""
    LUSID Website API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 0.4.1357
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid_web_app.configuration import Configuration


class OktaConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'base_url': 'str',
        'issuer': 'str',
        'client_id': 'str',
        'saml_identity_provider_id': 'str'
    }

    attribute_map = {
        'base_url': 'baseUrl',
        'issuer': 'issuer',
        'client_id': 'clientId',
        'saml_identity_provider_id': 'samlIdentityProviderId'
    }

    required_map = {
        'base_url': 'optional',
        'issuer': 'optional',
        'client_id': 'optional',
        'saml_identity_provider_id': 'optional'
    }

    def __init__(self, base_url=None, issuer=None, client_id=None, saml_identity_provider_id=None, local_vars_configuration=None):  # noqa: E501
        """OktaConfig - a model defined in OpenAPI"
        
        :param base_url: 
        :type base_url: str
        :param issuer: 
        :type issuer: str
        :param client_id: 
        :type client_id: str
        :param saml_identity_provider_id: 
        :type saml_identity_provider_id: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._base_url = None
        self._issuer = None
        self._client_id = None
        self._saml_identity_provider_id = None
        self.discriminator = None

        self.base_url = base_url
        self.issuer = issuer
        self.client_id = client_id
        self.saml_identity_provider_id = saml_identity_provider_id

    @property
    def base_url(self):
        """Gets the base_url of this OktaConfig.  # noqa: E501


        :return: The base_url of this OktaConfig.  # noqa: E501
        :rtype: str
        """
        return self._base_url

    @base_url.setter
    def base_url(self, base_url):
        """Sets the base_url of this OktaConfig.


        :param base_url: The base_url of this OktaConfig.  # noqa: E501
        :type base_url: str
        """

        self._base_url = base_url

    @property
    def issuer(self):
        """Gets the issuer of this OktaConfig.  # noqa: E501


        :return: The issuer of this OktaConfig.  # noqa: E501
        :rtype: str
        """
        return self._issuer

    @issuer.setter
    def issuer(self, issuer):
        """Sets the issuer of this OktaConfig.


        :param issuer: The issuer of this OktaConfig.  # noqa: E501
        :type issuer: str
        """

        self._issuer = issuer

    @property
    def client_id(self):
        """Gets the client_id of this OktaConfig.  # noqa: E501


        :return: The client_id of this OktaConfig.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this OktaConfig.


        :param client_id: The client_id of this OktaConfig.  # noqa: E501
        :type client_id: str
        """

        self._client_id = client_id

    @property
    def saml_identity_provider_id(self):
        """Gets the saml_identity_provider_id of this OktaConfig.  # noqa: E501


        :return: The saml_identity_provider_id of this OktaConfig.  # noqa: E501
        :rtype: str
        """
        return self._saml_identity_provider_id

    @saml_identity_provider_id.setter
    def saml_identity_provider_id(self, saml_identity_provider_id):
        """Sets the saml_identity_provider_id of this OktaConfig.


        :param saml_identity_provider_id: The saml_identity_provider_id of this OktaConfig.  # noqa: E501
        :type saml_identity_provider_id: str
        """

        self._saml_identity_provider_id = saml_identity_provider_id

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OktaConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OktaConfig):
            return True

        return self.to_dict() != other.to_dict()
